//+------------------------------------------------------------------+
//|                                                Ost-lineTrend.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Nikolaj Ostapjuk"
#property link      "nikost@inbox.lv"

#property indicator_chart_window

extern string p1=" ";
extern int period=140;
extern double Filter=140.0;
extern string p2=" :";
extern int tol=1;
extern string p3=" :0-,";
extern string p4="1-,2-,";
extern int st=0;
int timeHigh,timeLow,timeHighOld,timeLowOld;
double high,low,highOld,lowOld,filter;
string No;
int nomer;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
    double per=Period();
    filter=Filter*MathSqrt(per);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
 while(nomer>0)
 {
 ObjectDelete(period+"_"+"lineMA"+nomer);
 nomer--;
 }  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i, 
       Counted_bars=IndicatorCounted();
   i=Bars-Counted_bars-1;
//----
      while(i>=0)                      //         
      {
       timeHigh=iHighest(NULL,0,MODE_HIGH,period,i+1);
       timeLow=iLowest(NULL,0,MODE_LOW,period,i+1);
       timeHighOld=iHighest(NULL,0,MODE_HIGH,period+period,i+1);
       timeLowOld=iLowest(NULL,0,MODE_LOW,period+period,i+1);
       high=High[iHighest(NULL,0,MODE_HIGH,period,i)];
       low=Low[iLowest(NULL,0,MODE_LOW,period,i)]; 
       highOld=High[timeHighOld];
       lowOld=Low[timeLowOld];   
      // double delta=(highOld-lowOld)/Point;
      double delta=MathAbs(MathAbs(high-highOld)-MathAbs(lowOld-low))/Point;
      if(delta>filter)  {
       if ((high>highOld) && (timeHighOld-timeHigh>14)) {CreateOb(Time[timeHighOld],highOld,Time[timeHigh],high);}
       if ((low<lowOld) && (timeLowOld-timeLow>14)) {CreateOb(Time[timeLowOld],lowOld,Time[timeLow],low);}
       }
       i--;                          //         
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+

void CreateOb(datetime t1,double k1,datetime t2, double k2)
   {
   nomer=nomer+1;
   No=period+"_"+"lineMA"+nomer;
   ObjectCreate(No, OBJ_TREND, 0, t1, k1, t2, k2);
   ObjectSet(No, OBJPROP_STYLE, st);
   ObjectSet(No, OBJPROP_WIDTH,tol);
   if(k2>k1)
   ObjectSet(No, OBJPROP_COLOR,Olive);
   else
   ObjectSet(No, OBJPROP_COLOR,FireBrick);
   }